﻿;30.03.2024 12:05-12:09 install font from memory
Enumeration
  #bt;basic text
  #bts;button save
  #ot ;ontop
  #numb
EndEnumeration
;Global *m
Global Dim Tok.s(255)

Global v$="Detoken 0.99b"
Global sn.s
For i=0 To 255
  If i<32
    Tok(i)="("+Str(i)+")"
  Else
    tok(i)=Chr(i)
  EndIf
Next i
IncludeFile "tokens.pbi"
;;1 CLEAR 24999: LOAD *"cehsc"CODE 4e4: RANDOMIZE USR 4e4: LOAD *"cehcd"CODE : RANDOMIZE USR 25e3+USR 46e3  
;Debug tok(129)

Procedure loadfile(f$)
  li.l=1
  
  fs.l=FileSize(f$)
  If fs>0
    If OpenFile(0,f$)
      ;check hobeta
      ;Debug UCase(GetExtensionPart(f$))
      If UCase(GetExtensionPart(f$))="$B"
        ch.l=0
        For i=0 To 14
          ch=ch + ReadAsciiCharacter(0) * 257 + i
        Next i
        ch=ch&$FFFF
        ;Debug Hex(ch)
        rch.u=ReadUnicodeCharacter(0)
        If ch<>rch
          If MessageRequester("Error","Wrong Hobeta checksum"+Str(ch)+" for "+#CRLF$+f$+#CRLF$+"Load file?", #PB_MessageRequester_YesNo)=#PB_MessageRequester_No 
            CloseFile(0)
            ProcedureReturn
          EndIf
        EndIf
      EndIf
      
      SetGadgetText(#bt,"")
      ;    ReadData(0,*m,fs)
      
      While Not Eof(0)
        lineN.l=ReadAsciiCharacter(0)*256+ReadAsciiCharacter(0)
        If lineN>16384
          Break
        EndIf
        
        l$=Str(lineN)+" "
        
        lineL.l=ReadAsciiCharacter(0)+256*ReadAsciiCharacter(0)
        If Eof(0)
          Break
        EndIf
        
        For i=1 To lineL
          a.a=ReadAsciiCharacter(0)
          If Eof(0) Or a=$0D
            Break
          EndIf
          
          If a=$0E
            ;Debug "number"
            va.a=ReadAsciiCharacter(0)
            ve.a=ReadAsciiCharacter(0)
            vd.a=ReadAsciiCharacter(0)
            vc.a=ReadAsciiCharacter(0)
            vb.a=ReadAsciiCharacter(0)
            ; 2030 If a<>0 THEN GO To 2070
            If va=0
              ; 2040 LET number=256*c+d
              numb.f=256*vc+vd
              ; 2050 If e=255 THEN LET number=number-65536
              If ve=255
                numb=numb-65536
              EndIf
              ; 2060 GO To 2130
            Else
              ; 2070 LET exponent=a-128
              expon=va-128
              ; 2080 LET sign=-1
              sign.l=-1
              ; 2090 If e<128 THEN LET sign=1
              If ve<128
                sign=1
              EndIf
              ; 2100 If e<128 THEN LET e=e+128
              If ve<128
                ve+128
              EndIf
              ; 2110 LET mantissa=e/256+d/65536+c/16777216+b/4294967296
              mant.f=ve/256+vd/65536+vc/16777216+vb/4294967296
              ; 2120 LET number=sign*2^exponent*mantissa
              numb=sign*Pow(2,expon)*mant
              
            EndIf
            ; 2130 PRINT number''
            
            nn$=StrF( numb,7 )
            
            If FindString(nn$,".")
              While Mid(nn$,Len(nn$),1)="0"
                nn$=Mid(nn$,1,Len(nn$)-1)
              Wend
            EndIf
            
            If Mid(nn$,Len(nn$),1)="."
              nn$=Mid(nn$,1,Len(nn$)-1)
            EndIf
            If GetGadgetState(#numb)
              l$=l$+"("+nn$+")"
            EndIf
          Else
            l$+tok(a)
          EndIf
          ;Debug l$
        Next i
        
        If li
          SetGadgetText(#bt,l$)
          li=0
        Else
          SetGadgetText(#bt,GetGadgetText(#bt)+#CRLF$+l$)
        EndIf
      Wend
      sn=f$
      CloseFile(0)
      SetWindowTitle(0,v$+" "+f$)
    EndIf
  EndIf 
EndProcedure

If OpenWindow(0, 0, 0, 512, 384+25, v$, #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  StringGadget(#bt,0,0,512,384, "",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
  ;StickyWindow(0,1)
  ButtonGadget(#bts,0,384,40,25,"Save"):GadgetToolTip(#bts,"Save text")
  CheckBoxGadget(#ot,40,384,40,25,"Top"):GadgetToolTip(#ot,"Stay on top")
  CheckBoxGadget(#numb,80,384,60,25,"Number"):GadgetToolTip(#numb,"Check numbers after $0E")
  EnableGadgetDrop(#bt,#PB_Drop_Files,#PB_Drag_Copy)
  If(OpenLibrary(0, "GDI32.DLL"))
    hfont=CallFunction(0, "AddFontMemResourceEx", ?font, (?end_font -?font), 0, @"1")
    ;SendMessage_(GadgetID(#ds),#WM_SETFONT,hfont,$0)
    LoadFont(0,"ZX_SPECTRUM",8)
    SetGadgetFont(#bt,FontID(0))
    CloseLibrary(0)
  Else
    hfont=0
  EndIf

;   If LoadFont(1, "ZX_SPECTRUM", 8)
;     SetGadgetFont(#bt, FontID(1))
;   EndIf
  
  ;   CreateImage(0, 8, 8)
  ; StartDrawing(ImageOutput(0))
  ;  Box(0,0,12,20,(#Yellow ! RGB(136,136,064))) ;The req color xor The back color
  ;  StopDrawing()
  
  sn=""
  If CountProgramParameters()
    loadfile(ProgramParameter(0))
  EndIf
  
  Repeat
    ev=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf
    Select ev
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #ot
            StickyWindow(0,GetGadgetState(#ot))
          Case #bt
            DestroyCaret_()
            CreateCaret_(GadgetID(#bt),0,8,8)
            SetCaretBlinkTime_(500) ; immobile = -1, normal blinking = 500
            ShowCaret_(0)
            
          Case #bts
            If sn<>""
              If CreateFile(0,sn+".txt")
                WriteStringN(0,GetGadgetText(#bt))
                CloseFile(0)
              Else
                MessageRequester("Save as text","Error write:"+sn,#PB_MessageRequester_Ok)
              EndIf
            Else
              MessageRequester("Eeeeh?","Nothin for save",#PB_MessageRequester_Ok)
            EndIf
        EndSelect
        
      Case #PB_Event_GadgetDrop
        t$ = EventDropFiles()
        t$ = StringField(t$, 1, Chr(10))
        loadfile(t$)
    EndSelect
  Until ev = #PB_Event_CloseWindow
If hfont
  If(OpenLibrary(0, "GDI32.DLL"))
    CallFunction(0, "RemoveFontMemResourceEx",hfont);<>0 if OK,0 if error
    CloseLibrary(0)
  EndIf
EndIf

EndIf

DataSection
  font:
  IncludeBinary "ZX_Spec.fon"
  end_font:
; IDE Options = PureBasic 5.30 (Windows - x86)
; Folding = -
; EnableXP
; UseIcon = zxtok.ico
; Executable = detok.exe